// -*- C++ -*-
/**
 * Code generated by the The ACE ORB (TAO) IDL Compiler v3.0.11
 * TAO and the TAO IDL Compiler have been developed by:
 *       Center for Distributed Object Computing
 *       Washington University
 *       St. Louis, MO
 *       USA
 * and
 *       Distributed Object Computing Laboratory
 *       University of California at Irvine
 *       Irvine, CA
 *       USA
 * and
 *       Institute for Software Integrated Systems
 *       Vanderbilt University
 *       Nashville, TN
 *       USA
 *       https://www.isis.vanderbilt.edu/
 *
 * Information about TAO is available at:
 *     https://www.dre.vanderbilt.edu/~schmidt/TAO.html
 **/

// TAO_IDL - Generated from
// /home/abuild/rpmbuild/BUILD/ACE_wrappers/TAO/TAO_IDL/be/be_codegen.cpp:580

#ifndef _TAO_IDL_PORTABLESERVER_POLICYS_T_41AMGM_H_
#define _TAO_IDL_PORTABLESERVER_POLICYS_T_41AMGM_H_

#include /**/ "ace/pre.h"

TAO_BEGIN_VERSIONED_NAMESPACE_DECL


// TAO_IDL - Generated from
// /home/abuild/rpmbuild/BUILD/ACE_wrappers/TAO/TAO_IDL/be/be_visitor_root/root_sth.cpp:64

namespace POA_CORBA
{
  // TAO_IDL - Generated from
  // /home/abuild/rpmbuild/BUILD/ACE_wrappers/TAO/TAO_IDL/be/be_visitor_interface/tie_sh.cpp:70

  // TIE class: Refer to CORBA v2.2, Section 20.34.4
  template <class T>
  class  Policy_tie : public Policy
  {
  public:
    /// the T& ctor
    Policy_tie (T &t);
    /// ctor taking a POA
    Policy_tie (T &t, PortableServer::POA_ptr poa);
    /// ctor taking pointer and an ownership flag
    Policy_tie (T *tp, ::CORBA::Boolean release = true);
    /// ctor with T*, ownership flag and a POA
    Policy_tie (
        T *tp,
        PortableServer::POA_ptr poa,
        ::CORBA::Boolean release = true);
    /// dtor
    ~Policy_tie ();
    // TIE specific functions
    /// return the underlying object
    T *_tied_object ();
    /// set the underlying object
    void _tied_object (T &obj);
    /// set the underlying object and the ownership flag
    void _tied_object (T *obj, ::CORBA::Boolean release = true);
    /// do we own it
    ::CORBA::Boolean _is_owner ();
    /// set the ownership

    void _is_owner (::CORBA::Boolean b);
    // overridden ServantBase operations
    PortableServer::POA_ptr _default_POA ();
    // TAO_IDL - Generated from
    // /home/abuild/rpmbuild/BUILD/ACE_wrappers/TAO/TAO_IDL/be/be_visitor_operation/tie_sh.cpp:50

    ::CORBA::PolicyType policy_type ();
    // TAO_IDL - Generated from
    // /home/abuild/rpmbuild/BUILD/ACE_wrappers/TAO/TAO_IDL/be/be_visitor_operation/tie_sh.cpp:50

    ::CORBA::Policy_ptr copy ();
    // TAO_IDL - Generated from
    // /home/abuild/rpmbuild/BUILD/ACE_wrappers/TAO/TAO_IDL/be/be_visitor_operation/tie_sh.cpp:50

    void destroy ();
  
  private:
    T *ptr_;
    PortableServer::POA_var poa_;
    ::CORBA::Boolean rel_;

    Policy_tie (const Policy_tie &) = delete;
    void operator= (const Policy_tie &) = delete;
  };
} // module CORBA
// TAO_IDL - Generated from
// /home/abuild/rpmbuild/BUILD/ACE_wrappers/TAO/TAO_IDL/be/be_codegen.cpp:1790



TAO_END_VERSIONED_NAMESPACE_DECL



#if defined (ACE_TEMPLATES_REQUIRE_SOURCE)
#include "PolicyS_T.cpp"
#endif /* defined REQUIRED SOURCE */

#if defined (ACE_TEMPLATES_REQUIRE_PRAGMA)
#pragma implementation ("PolicyS_T.cpp")
#endif /* defined REQUIRED PRAGMA */

#include /**/ "ace/post.h"
#endif /* ifndef */

